#ifndef MESH_H
#define MESH_H

#include <Linear.h>


// Define the Data Structures, Mesh class.  
// (Merged the Mesh.h/.cc classes from triedgecol and
// trisliver...)

struct Triangle;

// Vertex -- used by both
struct Vertex {
  Vec3f coord;
  int index;	
  float confidence;	
  
  Triangle **tris;	
  uchar numTris;	

  Vertex **verts;	
  uchar numVerts;	
  
  uchar maxTris;	
  uchar maxVerts;

  bool onBoundary; // Is true if the vertex is on a mesh boundary.
};

// Triangle -- used by both

/* added voxels field to Triangle so triangle can
   keep track of which voxel in the .vri file it
   came from - for display voxel feature */

struct Triangle {
  Vertex *vert1, *vert2, *vert3;
  Vec3f norm;
  float voxelX, voxelY, voxelZ;
};

// Mesh -- used by both
class Mesh {

  public:

  int numVerts;	
  Vertex *verts;
  
  int numTris;	
  Triangle *tris;

  bool hasVoxels;

  Mesh();			
  ~Mesh();
};


#endif // MESH_H
